<?php

// This file is part of Photos
// Copyright (c) 2001-2004 Alex King
// see LICENSE.txt for more information

require_once("objects.inc.php");
require_once("database.inc.php"); 
require_once("functions.inc.php");
require_once("config.inc.php");
require_once('languages/'.$custom->language.'.php');

// suppress Notice messages
ini_set ('display_errors', '0');
ini_set ('error_reporting', E_PARSE);

// ---------------------------------------------------------------------------
// get image and spit out data

$image_entry = new image;

if (!empty($_REQUEST["id"]) || !empty($_REQUEST["URL"])) {
	if (!empty($_REQUEST["id"])) {
		$image_entry = $image_entry->retrieve(intval($_REQUEST["id"]));
		$exif = read_exif_data_quick($image_entry->URL);
		$title = $lang->str("photo_num", array($image_entry->id));
	}
	else if (!empty($_REQUEST["URL"])) {
		$exif = read_exif_data_quick($_REQUEST["URL"]);
		$title = substr($_REQUEST["URL"], (strrpos($_REQUEST["URL"], "/") + 1));
	}

	$exif_data_rows = "";
	
	ksort($exif);
	reset($exif);	
	while(list($k,$v) = each($exif)) {
		if ($k != "Thumbnail" && 
		    $k != "FileName" && 
		    $k != "VerboseOutput" && 
		    $k != "RAWDATA") {
			if ($k == "ExposureTime") {
				$v = get_friendly_shutter($v)." second(s)";
			}
			if ($k == "ApertureValue") {
				$v = "f ".get_friendly_fnumber($v);
			}
			if ($k == "FocalLength") {
				if ($v != 'INF') {
					$v .= " mm";
				}
			}
			$exif_data_rows .= "<tr valign=\"top\">\n"."\t<td width=\"1%\" align=\"right\" nowrap>$k:</td>\n"."\t<td>$v</td>\n"."</tr>\n";
		}
	}
	if (empty($exif_data_rows)) {
		$exif_data_rows = "<tr valign=\"top\">\n"."\t<td>".$lang->str("no_exif")."</td>\n"."</tr>\n";
	}
}
else {
	$exif_data_rows = "<tr valign=\"top\">\n"."\t<td>".$lang->str("err_no_photo_specified")."</td>\n"."</tr>\n";
	$image_entry->id = "None Specified";
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title><?php print($lang->str("exif_for", array($title))); ?></title>
	<link rel="stylesheet" type="text/css" href="css/main.css">
	<link rel="stylesheet" type="text/css" href="css/popup.css">
</head>
<body onload="self.focus();">

<div class="groupBorder">
	<div class="groupHeader"><?php print($lang->str("exif_for", array($title))); ?></div>
	<table width="100%" cellpadding="0" cellspacing="7">

<? 
print($exif_data_rows);
?>

	</table>
</div>

<? 
$database->disconnect(); 
?>

</body>
</html>

