<?php

// Photos
//
// Copyright (c) 2001-2004 Alex King
// http://www.alexking.org/software/photos/
//
// **********************************************************************
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// *****************************************************************

ini_set ('display_errors', '0');
ini_set ('error_reporting', E_PARSE);

$timer = microtime(); // start page timer

$debug = 0;				// set to 1 to display various debug information

// includes
require_once("objects.inc.php");
require_once("database.inc.php"); 
require_once("functions.inc.php");
require_once("config.inc.php");
require_once('languages/'.$custom->language.'.php');
require_once("compatibility.inc.php");
require_once("set_up.inc.php");

session_start();

// ---------------------------------------------------------------------------
// set up variables

$page = new page;

if (!empty($_REQUEST["screen"])) {
	$screen = $_REQUEST["screen"];
}
else {
	$screen = "search"; 
}
if (!empty($_REQUEST["id"])) {
	$id = $_REQUEST["id"];
}
if (!empty($_REQUEST["action"])) {
	$action = $_REQUEST["action"];
}
else {
	$action = "";
}
if (!empty($_REQUEST["override"])) {
	$override = $_REQUEST["override"];
}
else {
	$override = 0;
}
if (!empty($_REQUEST["cleanURL"])) {
	$cleanURL = stripslashes($_REQUEST["cleanURL"]);
}
else {
	$cleanURL = "";
}
if (!empty($_REQUEST["nav_command"])) {
	$nav_command = $_REQUEST["nav_command"];
}
if (!empty($_REQUEST["entry_shortcut_id"])) {
	$entry_shortcut_id = $_REQUEST["entry_shortcut_id"];
}
else {
	$entry_shortcut_id = "";
}

if ($debug == 1) {
	foreach ($_REQUEST as $k => $v) {
		print($k.': '.$v."\n");
	}
	print_r($_SESSION);
}

$show_image = 1;
$show_body = 1;

// ---------------------------------------------------------------------------

// check for passed in path
if (!empty($_REQUEST["path"])) {
	$_REQUEST["path"] = stripslashes($_REQUEST["path"]);
	if (is_file($_REQUEST["path"]) && strtolower(substr($_REQUEST["path"], -4, 4)) == ".jpg") {
		$screen = "entry";
		$cleanURL = $_REQUEST["path"];
		$action = "load_image";
	}
	if (!is_dir($_REQUEST["path"]) && (!is_file($_REQUEST["path"]) || strtolower(substr($_REQUEST["path"], -4, 4)) != ".jpg")) {
		$page->msgs[] = new msg('error'
		                       ,$lang->str("err_invalid_path", array(html(stripslashes($_REQUEST["path"]))))
		                       );
	}
}

// get the screen ready
require('engine.inc.php');

header("Content-Type: text/html; charset=".$lang->charset);

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title><? print($page->title); ?></title>
	<script type="text/javascript" src="js/main.js"></script>
	<script type="text/javascript" src="js/photos.js"></script>
	<script type="text/javascript" src="js/strings.php"></script>
	<script language="JavaScript">
	<!-- // set up variables
		var calMonths = <?php print($custom->date_picker_months); ?>;
		
		var currentMonth = '<?=date('m')?>';
		var currentDay = '<?=date('d')?>';
		var currentYear = '<?=date('Y')?>';
<?
$temp = mktime() - (7 * 86400);
?>
		var lastWeekMonth = '<?=date('m', $temp)?>';
		var lastWeekDay = '<?=date('d', $temp)?>';
		var lastWeekYear = '<?=date('Y', $temp)?>';
<?
$temp = mktime() - (30 * 86400);
?>
		var last30Month = '<?=date('m', $temp)?>';
		var last30Day = '<?=date('d', $temp)?>';
		var last30Year = '<?=date('Y', $temp)?>';
		
		var sEnterPath = '<?php print(str_replace("'", "/'", $lang->str("js_enter_path"))); ?>';

<?
if ($screen == "resolve") {
?>
function resolve(field, action) {
	switch (field) {
		case "title":
			if (action == "use") {
				document.edit.title.value = "<? print(html($old_image->title)); ?>";
			}
			else if (action == "append") {
				document.edit.title.value += "<? print(html($old_image->title)); ?>";
			}
			break;
		case "description":
			if (action == "use") {
				document.edit.description.value = "<? print(html($old_image->description)); ?>";
			}
			else if (action == "append") {
				document.edit.description.value += "<? print(html($old_image->description)); ?>";
			}
			break;
		case "keywords":
			if (action == "use") {
				document.edit.keywords.value = "<? print(html($old_image->keywords)); ?>";
			}
			else if (action == "append") {
				document.edit.keywords.value += "<? print(html($old_image->keywords)); ?>";
			}
			break;
		case "people":
			if (action == "use") {
				document.edit.people.value = "<? print(html($old_image->people)); ?>";
			}
			else if (action == "append") {
				document.edit.people.value += "<? print(html($old_image->people)); ?>";
			}
			break;
		case "event":
			if (action == "use") {
				document.edit.event.value = "<? print(html($old_image->event)); ?>";
			}
			else if (action == "append") {
				document.edit.event.value += "<? print(html($old_image->event)); ?>";
			}
			break;
		case "photographer":
			if (action == "use") {
				document.edit.photographer.value = "<? print(html($old_image->photographer)); ?>";
			}
			break;
		case "location":
			if (action == "use") {
				document.edit.location.value = "<? print(html($old_image->location)); ?>";
			}
			else if (action == "append") {
				document.edit.location.value += "<? print(html($old_image->location)); ?>";
			}
			break;
		case "state":
			if (action == "use") {
				document.edit.state.value = "<? print(html($old_image->state)); ?>";
			}
			break;
		case "country":
			if (action == "use") {
				document.edit.country.value = "<? print(html($old_image->country)); ?>";
			}
			else if (action == "append") {
				document.edit.country.value += "<? print(html($old_image->country)); ?>";
			}
			break;
		case "indoors":
			setSelectToValue(document.edit.indoors, "<? print($old_image->indoors); ?>");
			break;
		case "URL":
			if (action == "use") {
				document.edit.URL.value = "<? print(html($old_image->URL)); ?>";
			}
			break;
		case "datetaken":
			if (action == "use") {
				document.edit.datetaken.value = "<? print(html($old_image->datetaken)); ?>";
			}
			break;
		case "portfolio":
			if (<? print($old_image->portfolio); ?> == 1) {
				if (!document.edit.portfolio.checked) {
					toggleCheckbox(document.edit.portfolio);
				}
			}
			else {
				if (document.edit.portfolio.checked) {
					toggleCheckbox(document.edit.portfolio);
				}
			}
			break;
	}
}
<?
}
?>

	//-->
	</script>
	<link rel="stylesheet" href="css/main.css" type="text/css">
	<link rel="stylesheet" href="css/photos.css" type="text/css">
	<link rel="SHORTCUT ICON" href="favicon.ico">
</head>
<body onload="<? print($page->init_string); ?>">

<table width="100%" height="100%" cellpadding="0" cellspacing="0">
	<tr valign="top">
		<td rowspan="2" id="menu_area">
<?php

$menu_items = array();

$menu_items[] = new menu_item('images/icon_search.gif'
                             ,"index.php?screen=search"
                             ,$lang->str("menu_search", array(), 'ret')
                             ,$lang->str("menu_search_tip", array(), 'ret')
                             );
$menu_items[] = new menu_item('images/icon_new.gif'
                             ,"index.php?screen=load_folder"
                             ,$lang->str("menu_add_photos", array(), 'ret')
                             ,$lang->str("menu_add_photos_tip", array(), 'ret')
                             );
$menu_items[] = new menu_item('images/icon_details.gif'
                             ,"index.php?screen=entry&action=add_details"
                             ,$lang->str("menu_add_details", array(), 'ret')
                             ,$lang->str("menu_add_details_tip", array(), 'ret')
                             );
$menu_items[] = new menu_item('images/icon_portfolio.gif'
							 ,"index.php?screen=portfolio"
							 ,$lang->str("menu_portfolio", array(), 'ret')
							 ,$lang->str("menu_portfolio_tip", array(), 'ret')
							 );
$menu_items[] = new menu_item('images/icon_history.gif'
                             ,"index.php?screen=history"
                             ,$lang->str("menu_history", array(), 'ret')
                             ,$lang->str("menu_history_tip", array(), 'ret')
                             );
?>
			<ul id="menu">
<?
foreach ($menu_items as $menu) {
	$menu->show();
}
?>
			</ul>
<?

// get count of images
$result = mysql_query("SELECT COUNT(ID) FROM $database->table_name")
	or die("Couldn't get count of images. ".mysql_error());
$entries_total = mysql_result($result,0);

// get count of images that need details
$result = mysql_query("SELECT COUNT(ID) FROM $database->table_name WHERE needdetails = '1'")
	or die("Couldn't get count of images that need details. ".mysql_error());
$entries_needdetails = mysql_result($result,0);

// get count of portfolio images
$result = mysql_query("SELECT COUNT(ID) FROM $database->table_name WHERE (portfolio = '1')")
	or die("Couldn't get count of images that need details. ".mysql_error());
$entries_portfolio = mysql_result($result,0);

?>
			<ul id="menu_links" style="margin-top: 10px;">
				<li><?php print($lang->str("menu_entries", array($entries_total))); ?></li>
				<li><?php print($lang->str("menu_need_details", array($entries_needdetails))); ?></li>
				<li><?php print($lang->str("menu_in_portfolio", array($entries_portfolio))); ?></li>
			</ul>
			<img src="images/side_text.gif" width="100" height="300">
		</td>
		<td style="padding: 10px;">
<?php
if (count($page->msgs) > 0) {
	print('			<div id="messages">'."\n"
	     .'			<div class="title">'.$lang->str("messages_title").'</div>'."\n"
	     .'				<ul>'."\n"
	     );
	for ($i = 0; $i < count($page->msgs); $i++) {
		if ($i + 1 == count($page->msgs)) {
			$page->msgs[$i]->show(' style="border-bottom: 0;"');
		}
		else {
			$page->msgs[$i]->show();
		}
	}
	print('				</ul>'."\n"
	     .'			</div>'."\n"
	     );
}
if ($show_body == 1) {
	include($page->body);
}

if ($show_image == 1 && isset($preview_dimensions) && $preview_dimensions != false) { 
	print("			<p>".$lang->str("preview")."\n");
	for ($i = 0; $i < count($preview_dimensions); $i++) {
		print("			<a href=\"javascript:sizeImg('".$preview_dimensions[$i][0]."', '".$preview_dimensions[$i][1]."', 'viewImg');\">".$preview_dimensions[$i][0]." x ".$preview_dimensions[$i][1]."</a>\n");
		if (($i + 1) != count($preview_dimensions)) {
			print(' | ');
		}
	}
?>
			<p align="center">
<? 
	if (!empty($image_entry->URL)) {
		if ($image_entry->orientation == 0) { 
			$temp = $custom->preview_size_landscape;
			$i = 1;
		} 
		else { 
			$temp = $custom->preview_size_portrait;
			$i = 2;
		} 
		switch ($temp) {
			case 800:
				$i = 0;
				break;
			case 640;
				$i = 1;
				break;
			case 320;
				$i = 2;
				break;
		}
?>
			<img src="<? echo $image_entry->display_URL ; ?>" width="<? echo $preview_dimensions[$i][0] ; ?>" height="<? echo $preview_dimensions[$i][1] ; ?>" name="viewImg" class="onePixelBorder">
<?
	} 
	else { 
?>
			<img src="images/clear.gif" width="640" height="426" name="viewImg" class="onePixelBorder">
<?
	}
}
?>
		</td>
	</tr>
	<tr valign="bottom">
		<td style="padding: 7px;">
			<span class="legalText"><?php print($lang->str("legal", array('2001-'.date('Y'), '<a class="legalText" href="http://www.alexking.org/software/photos/" target="_blank">alexking.org</a>'))); ?> <a class="legalText" href="index.php?screen=about"><?php print($lang->str("about")); ?></a></span>
			<br />
<?
include("version.inc.php");
if (isset($this_version)) {
	print("			<span class=\"legalText\">".$lang->str("version", array($this_version))."</span><br />\n");
}
$timer = microtime_diff($timer, microtime());
$timer = sprintf("%0.3f", $timer);
print("			<span class=\"legalText\">".$lang->str("screen_rendered", array($timer))."</span>");
?>
		</td>
	</tr>
</table>

<div id="delete" class="popUp" style="display: none; z-index: 999; position: absolute; top: 100px; right: 250px; width: 350;">
	<table width="100%" cellpadding="5" cellspacing="0">
		<tr class="rowHeader">
			<td><?php print($lang->str("delete_photo_title")); ?></td>
		</tr>
		<tr class="rowEven">
			<td><?php print($lang->str("delete_photo_instructions")); ?></td>
		</tr>
<? 
if ($custom->delete_file == 1) {
?>
		<tr class="rowEven">
			<td><input type="checkbox" id="delete_file_checkbox"> <span onclick="toggleCheckbox(document.getElementById('delete_file_checkbox'));" class="hand"><?php print($lang->str("delete_photo_file_option")); ?></span></td>
		</tr>
<?
}
?>
		<tr class="rowButtons">
			<td align="center">
				<input type="button" onclick="if (confirmDeleteFile() == false) { location.href='index.php?screen=confirm&id=<? print($image_entry->id); ?>&action=delete'; }" value="<?php print($lang->str("button_delete_entry")); ?>" />
				&nbsp;
				<input type="button" onclick="toggleDiv('delete');" value="<?php print($lang->str("button_cancel")); ?>" />
			</td>
		</tr>
	</table>
</div>
<div id="delete_file" class="popUp" style="display: none; z-index: 999; position: absolute; top: 100px; right: 250px; width: 350;">
	<table width="100%" cellpadding="5" cellspacing="0">
		<tr class="rowHeader">
			<td><?php print($lang->str("delete_photo_title")); ?></td>
		</tr>
		<tr class="rowEven">
			<td><?php print($lang->str("delete_photo_file_confirm")); ?></td>
		</tr>
		<tr class="rowButtons">
			<td align="center">
				<input type="button" onclick="location.href='index.php?screen=confirm&id=<? print($image_entry->id); ?>&action=delete_file';" value="<?php print($lang->str("button_delete_entry_file")); ?>" />
				&nbsp;
				<input type="button" onclick="toggleDiv('delete_file');" value="<?php print($lang->str("button_cancel")); ?>" />
			</td>
		</tr>
	</table>
</div>
<div id="hidden_buttons" style="width: 1; height: 1; position: absolute; top: -2000; left: -2000;">
      <button accesskey="<?php $lang->str("accesskey_add_photo", array(), 'print'); ?>" onclick="location.href='index.php?screen=entry';">Add Photo (a)</button>
      <button accesskey="<?php $lang->str("accesskey_search", array(), 'print'); ?>" onclick="location.href='index.php?screen=search';">Search (h)</button>
      <button accesskey="<?php $lang->str("accesskey_add_folder", array(), 'print'); ?>" onclick="location.href='index.php?screen=load_folder';">Add Folder (f)</button>
      <button accesskey="<?php $lang->str("accesskey_add_details", array(), 'print'); ?>" onclick="location.href='index.php?screen=entry&action=add_details';">Add Details (d)</button>
      <button accesskey="<?php $lang->str("accesskey_portfolio", array(), 'print'); ?>" onclick="location.href='index.php?screen=portfolio';">Porfolio (p)</button>
      <button accesskey="<?php $lang->str("accesskey_title", array(), 'print'); ?>" onclick="setFocus();">Set Focus to Title/Load Field (t)</button>
      <button accesskey="<?php $lang->str("accesskey_history", array(), 'print'); ?>" onclick="location.href='index.php?screen=history';">History (r)</button>
</div>

</body>
</html>

