<?php

// This file is part of Photos
// Copyright (c) 2001-2004 Alex King
// see LICENSE.txt for more information

require_once("objects.inc.php");
require_once("database.inc.php"); 
require_once("functions.inc.php");
require_once("config.inc.php");
require_once('languages/'.$custom->language.'.php');

// suppress Notice messages
ini_set ('display_errors', '0');
ini_set ('error_reporting', E_PARSE);

// ---------------------------------------------------------------------------
// get image and spit out data

$image_entry = new image;

if (!empty($_REQUEST["id"]) || !empty($_REQUEST["URL"])) {
	if (!empty($_REQUEST["id"])) {
		$image_entry = $image_entry->retrieve($_REQUEST["id"]);
		$title = "Photo #".$image_entry->id;
	}
	else if (!empty($_REQUEST["URL"])) {
		$image_entry->URL = $_REQUEST["URL"];
		$title = substr($_REQUEST["URL"], (strrpos($_REQUEST["URL"], "/") + 1));
	}
	$iptc = getimagesize($_REQUEST["URL"], $info); 
	$iptc = iptcparse($info["APP13"]); 

	$data = array();
	
	$data["Caption"] = $iptc["2#120"][0];
	$data["Name"] = $iptc["2#005"][0];
	$data["Urgency"] = $iptc["2#010"][0];
	$data["Category"] = $iptc["2#015"][0];
	if (is_array($iptc["2#020"])) {
		foreach ($iptc["2#020"] as $temp) {
			$data["Category"] .= ' '.$temp;
		}
	}
	else {
		if (!empty($iptc["2#020"])) {
			$data["Category"] .= ' '.$iptc["2#020"];
		}
	}
	if (is_array($iptc["2#025"])) {
		foreach ($iptc["2#025"] as $temp) {
			$data["Category"] .= ' '.$temp;
		}
	}
	else {
		if (!empty($iptc["2#025"])) {
			$data["Category"] .= ' '.$iptc["2#025"];
		}
	}
	$data["Special Instructions"] = $iptc["2#040"][0];
	$data["Creation Date"] = $iptc["2#055"][0];
	$data["Photographer"] = $iptc["2#080"][0];
	$data["Position"] = $iptc["2#085"][0];
	$data["City"] = $iptc["2#090"][0];
	$data["State"] = $iptc["2#095"][0];
	$data["Country"] = $iptc["2#101"][0];
	$data["OTR"] = $iptc["2#103"][0];
	$data["Headline"] = $iptc["2#105"][0];
	$data["Credit"] = $iptc["2#110"][0];
	$data["Source"] = $iptc["2#115"][0];
	$data["Copyright Notice"] = $iptc["2#116"][0];

	$iptc_data_rows = "";
	
	foreach ($data as $k => $v) {
		if (!empty($v)) {
			$iptc_data_rows .= "<tr valign=\"top\">\n"."\t<td width=\"1%\" align=\"right\" nowrap>$k:</td>\n"."\t<td>$v</td>\n"."</tr>\n";
		}
	}
	if (empty($iptc_data_rows)) {
		$iptc_data_rows = "<tr valign=\"top\">\n"."\t<td>".$lang->str("no_iptc")."</td>\n"."</tr>\n";
	}
}
else {
	$iptc_data_rows = "<tr valign=\"top\">\n"."\t<td>".$lang->str("err_no_photo_specified")."</td>\n"."</tr>\n";
	$image_entry->id = "None Specified";
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title><?php print($lang->str("iptc_for", array($title))); ?></title>
	<link rel="stylesheet" type="text/css" href="css/main.css">
	<link rel="stylesheet" type="text/css" href="css/popup.css">
</head>
<body onload="self.focus();">

<div class="groupBorder">
	<div class="groupHeader"><?php print($lang->str("iptc_for", array($title))); ?></div>
	<table width="100%" cellpadding="0" cellspacing="7">

<? 
print($iptc_data_rows);
?>

	</table>
</div>

<? 
$database->disconnect(); 
?>

</body>
</html>

