<?php

// This file is part of Photos
// Copyright (c) 2001-2004 Alex King
// see LICENSE.txt for more information

// english language file

$lang = new language('Alex King' // author name
                    ,'http://www.alexking.org/' // author URL
                    ,'ISO-8859-I' // charset
                    ,'English' // language name
                    );

$lang->strings = array(

"photos" => "Photos"

// accesskeys (keyboard shortcuts)

,"accesskey_add_photo" => "a"
,"accesskey_add_folder" => "f"
,"accesskey_add_details" => "d"
,"accesskey_edit" => "v"
,"accesskey_history" => "y"
,"accesskey_portfolio" => "p"
,"accesskey_save" => "s"
,"accesskey_save_copy" => "c"
,"accesskey_search" => "h"
,"accesskey_search_button" => "q"
,"accesskey_title" => "e"
,"accesskey_view_exif" => "e"
,"accesskey_view_iptc" => "i"

// menu items

,"menu_add_details" => "Add <u>D</u>etails"
,"menu_add_details_tip" => "Click here to bring up the next photo that needs details added."
,"menu_add_photos" => "<u>A</u>dd Photos"
,"menu_add_photos_tip" => "Click here to load more photos."
,"menu_history" => "Histor<u>y</u>"
,"menu_history_tip" => "Click here to view the last edited photos."
,"menu_portfolio" => "<u>P</u>ortfolio"
,"menu_portfolio_tip" => "Click here to view your portfolio shots."
,"menu_search" => "Searc<u>h</u>"
,"menu_search_tip" => "Click here to go to the search page."
,"menu_entries" => "__0 Entries" // number
,"menu_need_details" => "__0 Need Details" // number
,"menu_in_portfolio" => "__0 in Portfolio" // number

// misc

,"about" => "About Photos"
,"button_cancel" => "Cancel"
,"button_delete_entry" => "Delete Entry"
,"button_delete_entry_file" => "Yes, Delete Entry and File"
,"delete_photo_title" => "Delete This Photo?"
,"delete_photo_instructions" => "This entry will be deleted from the database and all information about this photo will be lost. Are you sure this is what you want to do?"
,"delete_photo_file_confirm" => "Not only will the entry be deleted from the database, but this file will also be deleted (not moved to the trash) from your hard drive. Are you sure you want to do this?"
,"delete_photo_file_option" => "Also delete this file from the file system."
,"legal" => "Copyright &copy; __0 __1. All Rights Reserved." // year range, Alex King 
,"messages_title" => "Messages"
,"photo_num" => "Photo #__0" // id
,"screen_rendered" => "Screen rendered in __0 seconds."
,"version" => "Version __0" // number

// page titles

,"pt_about" => "About"
,"pt_add_photos" => "Add Photos"
,"pt_entry" => "Entry"
,"pt_history" => "History"
,"pt_photos" => "Photos"
,"pt_portfolio" => "Portfolio"
,"pt_problem" => "Configuration Problem"
,"pt_resolve" => "Resolve Conflict"
,"pt_search" => "Search"
,"pt_search_results" => "Search Results"
,"pt_title" => "Photos: __0"

// about page

,"download" => "Download"
,"documentation" => "Documentation"
,"forums" => "Discussion and Support Forums:"
,"home_page" => "Home Page:"
,"latest_beta" => "Latest beta:"
,"latest_release" => "Latest release:"
,"license" => "License"
,"read_me" => "Read Me"
,"tagline" => "so you can find your photos later."
,"this_version" => "This Version:"
,"using_latest_beta" => "You are using the latest beta version."
,"using_latest_release" => "You are using the latest release version."

// create table page

,"install_click_here" => "Click here to create your images table"
,"install_error" => "There was an error creating the database table."
,"install_insert_error" => "There was an error inserting the test record."
,"install_insert_success" => "One record was successfully inserted."
,"install_success" => "The database table should be set up now."

// entry page

,"apply_1" => "Apply (1)"
,"by_id" => "By ID"
,"photo_details" => "Photo __0 Details" // id
,"quick_entry_title" => "Quick Entry (copy from a previously entered photo)"

// view page

,"more" => "More"
,"photo_entry" => "Photo Entry"

// data

,"contact_sheet" => "Contact Sheet"
,"indoors" => "Indoors"
,"landscape" => "Landscape"
,"list_view" => "List View"
,"no" => "No"
,"off" => "Off"
,"on" => "On"
,"outdoors" => "Outdoors"
,"pixels" => "__0 pixels" // number
,"portrait" => "Portrait"
,"seconds" => "__0 second(s)" // number
,"yes" => "Yes"

// form

,"aperture" => "Aperture:"
,"camera_make" => "Camera Make:"
,"camera_model" => "Camera Model:"
,"country" => "Country:"
,"date_format" => "YYYY-MM-DD format"
,"date_taken" => "Date Taken:"
,"description" => "Description:"
,"event" => "Event:"
,"exposure_time" => "Exposure Time:"
,"flash" => "Flash:"
,"focal_length" => "Focal Length:"
,"height" => "Height:"
,"id" => "ID:"
,"in_outdoors" => "In/Outdoors:"
,"iso" => "ISO:"
,"last_modified" => "Last Modified:"
,"location" => "Location:"
,"keywords" => "Keywords:"
,"path" => "Path:"
,"people" => "People:"
,"photographer" => "Photographer:"
,"portfolio_shot" => "Portfolio Shot"
,"preview" => "Preview:"
,"state" => "State:"
,"title" => "Title:"
,"update_thumbnail" => "Update Thumbnail"
,"url" => "URL:"
,"width" => "Width:"

// messages

,"err_conflict" => "This photo was not saved.<br>This photo was updated by another user since you started editing it. Please review the differences listed below and save again. <p>The version of this photo you made changes to was last saved on __0;<br>the current version in the database was saved on __1" // date, date
,"err_invalid_date" => "The Date Taken is not a valid date. Correct the date and save again."
,"err_invalid_path" => "The path you entered (__0) does not appear to be a directory or a jpeg file (.jpg)." // path
,"err_no_id" => "No photo ID was specified."
,"err_no_photo" => "No photo entry of ID #__0" // id
,"err_photo_not_deleted" => "Error deleting __0 from the hard drive" // url
,"info_did_nothing" => "Didn't do anything"
,"info_image_count" => "This folder contains <b>__0</b> photos." // number
,"info_none_need_details" => "There are no photos that need details added."
,"info_photo_deleted" => "Photo __0 has been deleted from the hard drive." // url
,"info_photo_id_deleted" => "Photo record #__0 has been deleted from the database" // id
,"info_photos_deleted" => "__0 photo(s) have been deleted from the database." // number
,"info_saved" => "Saved Photo #__0 (__1) at __2" // id, title, date
,"info_still_add" => 'If you are sure you want to add this many photos all at once, <a href="__0">click here</a>. Otherwise you can <a href="javascript:history.go(-1);">go back</a> and choose a different folder.' // url
,"msg_error" => "Error:"
,"msg_info" => "Info:"
,"msg_warning" => "Warning:"
,"warn_already_in_db" => "An entry with URL: __0 was already in the database. You may have added a duplicate entry for this photo." // url
,"warn_already_in_db_link" => 'An entry with URL: __0 is already in the database. <a href="__1">Click here</a> to view the existing photo(s).' // url, url
,"warn_photos_in_db" => '__0 photo(s) from this folder (__1) already exist in the database. <a href="__2">Click here</a> to view the existing photo(s).'

// history

,"history_title" => "History (last 15 entered/edited photos)"

// toolbar

,"tb_clear" => "Clear"
,"tb_delete" => "Delete"
,"tb_edit" => "<u>E</u>dit"
,"tb_edit_tip" => "Edit"
,"tb_save" => "<u>S</u>ave"
,"tb_save_copy" => "Save a Copy"
,"tb_save_tip" => "Save"
,"tb_view_exif" => "<u>V</u>iew EXIF Data"
,"tb_view_iptc" => "View <u>I</u>PTC Data"

// popup windows

,"err_no_photo_specified" => "<span class=\"error\"><b>Error:</b> No photo was specified.</span>"
,"exif_for" => "EXIF Data for: __0" // title
,"iptc_for" => "IPTC Data for: __0" // title
,"no_exif" => "No EXIF data for this photo."
,"no_iptc" => "No IPTC data for this photo."

// list

,"desc" => "Desc.:"
,"file" => "File:"
,"first" => "First"
,"found_photo_showing_n" => "Found 1 photo, showing 1-1 of 1."
,"found_photos_showing_n" => "Found __0 photos, showing __1-__2 of __3." // number, number, number, number
,"last" => "Last"
,"lh_add_details" => "Add Details"
,"lh_date" => "Date"
,"lh_details" => "Details"
,"lh_event" => "Event"
,"lh_in_outdoors" => "In/Outdoors"
,"lh_keywords" => "Keywords"
,"lh_location" => "Location"
,"lh_people" => "People"
,"lh_portfolio_shot" => "Portfolio Shot"
,"lh_preview" => "Preview"
,"modified" => "Modified:"
,"next" => "Next"
,"no_photos_to_display" => "No photos to display."
,"previous" => "Previous"
,"show_per_page" => "Show __0 per page."
,"taken" => "Taken:"

// loading

,"add" => "Add"
,"add_details_later" => "Add Details Later"
,"add_different" => "add a different folder/file"
,"add_folder" => "Add Folder"
,"cancel" => "Cancel"
,"choose_folder_file" => "Choose the folder or file you want and click (Add)"
,"found_photos" => "Found __0 Photos in &quot;__1&quot;" // number, path
,"images_added" => "The following images have been added:"
,"no_folders_or_files" => "No folders or JPEG files (.jpg) in this folder."
,"path_instructions" => "Or enter the relative path to the folder or file you want to add"
,"photo_group_details" => "Photo Group Details"
,"processing_count" => "Processing photo 1 of __0" // number
,"review_photos" => "Review Photos"
,"saving_count" => "Saving __0 photos..." // number
,"status" => "Status"

// javascript strings

,"js_enter_path" => "Please enter a Folder Path."

// resolve

,"append" => "Append"
,"current_version" => "Current Version"
,"fields_different" => "The following fields have differences"
,"save" => "Save"
,"use" => "Use"
,"your_data" => "Your Data"

// picker

,"january" => "January"
,"february" => "February"
,"march" => "March"
,"april" => "April"
,"may" => "May"
,"june" => "June"
,"july" => "July"
,"august" => "August"
,"september" => "September"
,"october" => "October"
,"november" => "November"
,"december" => "December"
,"sun" => "Sun"
,"mon" => "Mon"
,"tue" => "Tue"
,"wed" => "Wed"
,"thu" => "Thu"
,"fri" => "Fri"
,"sat" => "Sat"
,"go" => "Go"
,"selected_date" => "Currently Selected Date"
,"today" => "Today"
,"todays_date" => "Today's Date"

// save a copy

,"90_small" => "90 (Small Thumbnail)"
,"160_thumb" => "160 (Thumbnail)"
,"320_3x5" => "320 (Digital 3x5)"
,"640_4x6" => "640 (Digital 4x6)"
,"800_8x10" => "800 (Digital 8x10)"
,"create_new_photo" => "Create New Photo"
,"created_copy" => "Successfully created copy of photo #__0." // id
,"for_larger_use_editor" => "For anything larger or for making physical prints, you are better off using an image editing program like Adobe Photoshop."
,"high" => "High"
,"higher_larger" => "Higher quality results in a larger file size."
,"highest" => "Highest"
,"low" => "Low"
,"lowest" => "Lowest"
,"medium" => "Medium"
,"new_file_name" => "New File Name:"
,"no_extension" => "Do NOT include the '.jpg' file extension."
,"quality" => "Quality:"
,"save_copy_of" => "Save a Copy of Photo #__0" // id
,"size_in_pixels" => "Size (in pixels) of Longest Edge:"
,"standard_sizes" => "Standard Sizes:"
,"view" => "View:"

// search page

,"and_less_than" => "and less than"
,"button_search" => "Search (q)"
,"choose_date" => "Choose Date"
,"clear" => "Clear"
,"last_30_days" => "Last 30 Days"
,"last_week" => "Last Week"
,"more_search_options" => "More Search Options"
,"more_than" => "more than"
,"need_details" => "Need Details:"
,"orientation" => "Orientation:"
,"search" => "Search"
,"title_desc" => "Title/Desc.:"
,"to" => "to:"

// transaction cancelled

,"photos_added_before_cancel" => "There were __0 photos saved before you hit cancel:" // number
,"remove_added_photos" => "Remove these photos from the database"

// javascript strings

,"js_enter_id_to_copy_from" => "Enter the ID of the Photo you want to copy data from."
,"js_errors_to_correct" => "The following error(s) need to be corrected:"
,"js_date_taken_format" => "The 'Date Taken' field is not properly formatted as 'YYYY-MM-DD'."
,"js_date_taken_from_invalid" => "The Date Taken from value is an invalid date."
,"js_date_taken_to_invalid" => "The Date Taken to value is an invalid date."
,"js_date_taken_range_invalid" => "The Date Taken search range is invalid, the 'after' value has to be less than the 'before' value."
,"js_ISO_range_invalid" => "The ISO search range is invalid, the 'more than' value has to be less than the 'less than' value."
,"js_aperture_range_invalid" => "The Aperture search range is invalid, the 'more than' value has to be less than the 'less than' value."
,"js_exposure_range_invalid" => "The Exposure Time search range is invalid, the 'more than' value has to be less than the 'less than' value."
,"js_focal_length_range_invalid" => "The Focal Length search range is invalid, the 'more than' value has to be less than the 'less than' value."
,"js_last_modified_from_invalid" => "The Last Modified from value is an invalid date."
,"js_last_modified_to_invalid" => "The Last Modified to value is an invalid date."
,"js_last_modified_range_invalid" => "The Last Modified search range is invalid, the 'after' value has to be less than the 'before' value."
,"js_processing_n_of_n" => "Processing photo __0 of __1" // number, number
,"js_finished" => "Finished."

);

?>