<?php

// This file is part of Photos
// Copyright (c) 2001-2004 Alex King
// see LICENSE.txt for more information

class custom {

/*******************************************************************
	* class custom
	*
	* used to scope custom settings in the app
	*
	* Methods:
	*	custom() - initialize variables
	*
	*/

	var $date_format;				// order of Y/M/D in display
	var $date_picker_months;		// number of months to show in the date picker
	var $datetaken_year_range;		// range of years available for $datetaken
	var $default_photographer;		// default entry for photo credit field
	var $delete_file;				// option to delete file from file system along with database record
	var $entry_country;				// default country when entering photos
	var $entry_state;				// default state when entering photos
	var $ignore_hidden_files;		// ignore files that begin with "."
	var $language;					// what language to use
	var $import_IPTC_data;			// import IPTC data (from data entered in Photoshop, etc.)
	var $load_folder_path;			// default path in add group folder path box
	var $local_server;				// running on this computer (1) or on a remote web server (0)
	var $minimize_data_transfer;	// show smaller temp files instead of full size photo files
	var $preview_size_landscape;	// default size for displaying photos on the view/edit screens
	var $preview_size_portrait;		// default size for displaying photos on the view/edit screens
	var $server_time_difference;	// time difference in hours
	var $use_beta;					// notify of new beta version on about page
//	var $use_imagemagick;			// use imagemagick for image manipulations

	function custom() { // set defaults
		$this->date_format = "m/d/y";
		$this->date_picker_months = 3;
		$this->datetaken_year_range = array(1997			// year from
                                           ,date('Y')		// year to
                                           );
		$this->default_photographer = "";
		$this->delete_file = 0;
		$this->entry_country = "";
		$this->entry_state = "";
		$this->ignore_hidden_files = 1;
		$this->import_IPTC_data = 0;
		$this->language = "english";
		$this->load_folder_path = "gallery_photos/";
		$this->local_server = 1;
		$this->minimize_data_transfer = 1;
		$this->preview_size_landscape = 640;
		$this->preview_size_portrait = 320;
		$this->server_time_difference = 0;
        $this->use_beta = 0;
//		$this->use_imagemagick = 0;
	}
}

?>