<?php

// This file is part of Photos
// Copyright (c) 2001-2004 Alex King
// see LICENSE.txt for more information

ini_set ('display_errors', '1');
ini_set ('error_reporting', E_ALL);

$debug = 0;

// includes
require_once("objects.inc.php");
require_once("database.inc.php"); 
require_once("functions.inc.php");
require_once("config.inc.php");
require_once('languages/'.$custom->language.'.php');

$page = new page;
$image_entry = new image;

// ---------------------------------------------------------------------------
// get image and spit out data

if ($debug == 1) {
	print_r(array_keys($_REQUEST));
	print_r(array_values($_REQUEST));
}

if (isset($_REQUEST["id"])) {
	$id = intval($_REQUEST["id"]);
	$image_entry = $image_entry->retrieve($id);
}
else {
	$page->msgs = new msg('error'
	                     ,$lang->str('err_no_id')
	                     );
	$image_entry->id = "None Specified";
}

if (isset($_REQUEST["action"])) {
	$action = $_REQUEST["action"];
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title><?php print($lang->str("save_copy_of", array($image_entry->id))); ?></title>
	<link rel="stylesheet" type="text/css" href="css/main.css">
	<link rel="stylesheet" type="text/css" href="css/popup.css">
</head>
<body onload="self.focus();">

<div class="groupBorder">
	<div class="groupHeader"><?php print($lang->str("save_copy_of", array($image_entry->id))); ?></div>
<? 
if (count($page->msgs) > 0) {
	print('			<div id="messages">'."\n"
	     .'			<div class="title">'.$lang->str("messages_title").'</div>'."\n"
	     .'				<ul>'."\n"
	     );
	for ($i = 0; $i < count($page->msgs); $i++) {
		if ($i + 1 == count($page->msgs)) {
			$page->msgs[$i]->show(' style="border-bottom: 0;"');
		}
		else {
			$page->msgs[$i]->show();
		}
	}
	print('				</ul>'."\n"
	     .'			</div>'."\n"
	     );
}
elseif (isset($action) && $action == "save_copy") {
	if (isset($_REQUEST["pixel_size"])) {
		$pixel_size = $_REQUEST["pixel_size"];
		if ($pixel_size > 3000) {
			$pixel_size = 3000;
		}
	}
	else {
		$pixel_size = 640;
	}
	if (isset($_REQUEST["file_name"])) {
		$file_name = $_REQUEST["file_name"];
	}
	else {
		$file_name = "copy_of_photo_".$image_entry->id;
	}
	if (isset($_REQUEST["quality"])) {
		$quality = $_REQUEST["quality"];
	}
	else {
		$quality = 70;
	}
	
	$new_file = save_JPEG_file_from_JPEG($image_entry->URL, $pixel_size, "saved_copies/", $file_name, $quality);

	if ($new_file != false) {
?>
	<table width="100%" cellpadding="0" cellspacing="7">
		<tr valign="top">
			<td>
				<p><?php print($lang->str("created_copy", array($image_entry->id))); ?>
				<p><?php print($lang->str("view")); ?> <a href="<? print($new_file); ?>" target="_blank" onclick="window.close()"><? print($new_file); ?></a>
			</td>
		</tr>
	</table>
<?
	}
}
else {
?>
	<table width="100%" cellpadding="0" cellspacing="7">
	<form name="imageForm" method="post" action="save_a_copy.php">
		<tr valign="top">
			<td>
				<?php print($lang->str("new_file_name")); ?>
				<input type="text" name="file_name" value="copy_of_photo_<? echo $image_entry->id; ?>" style="width: 100%;" class="onePixelBorder">
			</td>
			<td rowspan="8" width="1%"><img src="image.php?id=<? echo $image_entry->id; ?>" class="onePixelBorder"></td>
		</tr>
		<tr valign="top">
			<td><?php print($lang->str("no_extension")); ?></td>
		</tr>
		<tr valign="top">
			<td class="trHR"><img src="images/clear.gif" height="1" width="1"></td>
		</tr>
		<tr valign="top">
			<td>
				<?php print($lang->str("quality")); ?>
				<select name="quality" class="onePixelBorder">
					<option value="100"><?php print($lang->str("highest")); ?></option>
					<option value="80" selected><?php print($lang->str("high")); ?></option>
					<option value="60"><?php print($lang->str("medium")); ?></option>
					<option value="40"><?php print($lang->str("low")); ?></option>
					<option value="20"><?php print($lang->str("lowest")); ?></option>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<td><?php print($lang->str("higher_larger")); ?></td>
		</tr>
		<tr valign="top">
			<td class="trHR"><img src="images/clear.gif" height="1" width="1"></td>
		</tr>
		<tr valign="top">
			<td><?php print($lang->str("size_in_pixels")); ?> <input type="text" name="pixel_size" value="640" style="width: 50px;" class="onePixelBorder"></td>
		</tr>
		<tr valign="top">
			<td>
				<?php print($lang->str("standard_sizes")); ?>
				<ul>
					<li><?php print($lang->str("90_small")); ?>
					<li><?php print($lang->str("160_thumb")); ?>
					<li><?php print($lang->str("320_3x5")); ?>
					<li><?php print($lang->str("640_4x6")); ?>
					<li><?php print($lang->str("800_8x10")); ?>
				</ul>
				<?php print($lang->str("for_larger_use_editor")); ?>
				<br>&nbsp;
			</td>
		</tr>
		<tr valign="top">
			<td colspan="2"><input type="submit" name="submit" value="<?php print($lang->str("create_new_photo")); ?>"></td>
		</tr>
	<input type="hidden" name="id" value="<? echo $image_entry->id; ?>">
	<input type="hidden" name="action" value="save_copy">
	</form>
	</table>
</div>

<? 
}
$database->disconnect(); 
?>

</body>
</html>

