<?php

// This file is part of Photos
// Copyright (c) 2001-2004 Alex King
// see LICENSE.txt for more information

if (isset($_REQUEST["phpinfo"]) && $_REQUEST["phpinfo"] == 1) {
	phpinfo();
	die();
}

$set_up = array();

if (!extension_loaded("gd")) {
	$set_up[] = "<p><b>Error:</b> The 'gd2' PHP extension is not loaded. To enable the 'gd2' extension, PHP must have been compiled/installed with gd enabled and you must enable it in your PHP.ini file.";
}
/* this is causing a problem with a value that has more than one decimal (2.0.12) 
else {
	$temp = gd_info();
	if (!empty($temp["GD Version"]) && floatval($temp["GD Version"]) < 1.8) {
		$set_up[] = "<p><b>Error:</b> The 'gd2' PHP extension must be version 1.8 or later. Your version is :".$temp["GD Version"];
	}
}
*/

if (!function_exists("imagecreatefromjpeg")) {
	$set_up[] = "<p><b>Error:</b> The <a href=\"http://www.php.net/manual/en/function.imagecreatefromjpeg.php\">'imagecreatefromjpeg()' function</a> is not enabled. You must have this function enabled for photos to work properly.";
}

if (!is_writable("temp")) {
	$set_up[] = "<p><b>Error:</b> The 'temp' directory is not writable by the web server. You must change the permissions on the 'temp' directory before photos can work properly.";
}

if (!is_writable("saved_copies")) {
	$set_up[] = "<p><b>Error:</b> The 'saved_copies' directory is not writable by the web server. You must change the permissions on the 'saved_copies' directory before photos can work properly.";
}

if (file_exists("temp/read_exif_data_quick.temp") && 
    !is_writable("temp/read_exif_data_quick.temp")) {
	$set_up[] = "<p><b>Error:</b> The 'read_exif_info_quick.temp' file in the 'temp' directory is not writable by the web server. You must change the permissions on the 'read_exif_info_quick.temp' file before photos can work properly.";
}

$fields = mysql_list_fields($database->database_name, $database->table_name);

$table = 0;
$upgrade = 0;

for ($i = 0; $i < mysql_num_fields($fields); $i++) {
    if (mysql_field_name($fields, $i) == 'ID') {
    	$table++;
    }
    if (mysql_field_name($fields, $i) == 'shutter') {
    	$upgrade++;
    }
    if (mysql_field_name($fields, $i) == 'exposure') {
		$set_up[] = '<p><b>Error:</b> You must upgrade your database to use this version of photos. Click here to <a href="upgrade_from_3.5b1.php">run the upgrade script</a>.';
    }
}
if ($table == 0) {
	$set_up[] = '<p><b>Error:</b> You must set up your database table first to use photos. Make sure your database settings are correct in database.php, then click here to <a href="create_table.php">create the images table</a> in your database.';
}
if ($upgrade == 0) {
	$set_up[] = '<p><b>Error:</b> You must upgrade your database to use this version of photos. Click here to <a href="upgrade_from_gallery.php">run the upgrade script</a>.';
}

if (count($set_up) > 0) {
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title>Photos: <?php print($lang->str("pt_problem")); ?></title>
	<link rel="stylesheet" href="main.css" type="text/css">
	<link rel="stylesheet" href="photos.css" type="text/css">
	<link rel="SHORTCUT ICON" href="favicon.ico">
</head>
<body>

<?
print("			<div class=\"messages\">\n");
print("			<div class=\"messages_title\">Messages</div>\n");
print("				<table width=\"100%\" cellpadding=\"0\" cellspacing=\"4\">\n");
foreach ($set_up as $temp) {
	print("					<tr>\n");
	print("						<td>".$temp."</td>\n");
	print("					</tr>\n");
}
print("				</table>\n");
print("			</div>\n");
?>

</body>
</html>
<?
	die();
}

?>